package simplerace;

/**
 * Created by IntelliJ IDEA.
 * User: julian
 * Date: Feb 12, 2007
 * Time: 4:43:24 PM
 */
public class CompetitionScore {

    final static String evolvedControllerToTestAgainst = "fixedcompetitor.xml";


    public static void main(String[] args) {
        // tests the submitted controller 100 times on its own,
        // 100 times against the heuristic controller
        // and 100 times against a good evolved controller

        Controller controller = Play.load (args[0]);
        System.out.println ("Testing the controller on its own...");
        double soloScore = Stats.soloStats (controller).mean ();
        System.out.println (" Solo score: " + soloScore);
        System.out.println ("Testing the controller against the sensible heuristic controller...");
        double sensibleHeuristicScore = Stats.duoStats (controller, new HeuristicSensibleController ())[0].mean ();
        System.out.println (" Score against sensible heuristic controller: " + sensibleHeuristicScore);
        System.out.println ("Testing the controller against the combined heuristic controller...");
        double combinedHeuristicScore =
                Stats.duoStats (controller, new HeuristicCombinedController ())[0].mean ();
        System.out.println (" Score against combined heuristic controller: " + combinedHeuristicScore);
       /* System.out.println ("Testing the controller against the underdog heuristic controller...");
        double underdogHeuristicScore = Stats.duoStats (controller, new HeuristicUnderdogController ())[0].mean ();
        System.out.println (" Score against underdog heuristic controller: " + underdogHeuristicScore);  */

       /* System.out.println ("Testing the controller against the the fixed evolved competitor (" +
                evolvedControllerToTestAgainst+ ")...");
        Controller fixedCompetitor = Play.load (evolvedControllerToTestAgainst);
        double fixedCompetitorScore = Stats.duoStats (controller, fixedCompetitor)[0].mean ();
        System.out.println (" Score against fixed evolved competitor: " + fixedCompetitorScore);   */


        double competitionScore = (soloScore + sensibleHeuristicScore +
                combinedHeuristicScore ) / 3;
        //double competitionScore = (soloScore + sensibleHeuristicScore + fixedCompetitorScore) / 3;
        System.out.println ("\n\nCompetition score (mean of the above): " + competitionScore);
    }

}
