package simplerace;

import gp.DoubleGP;

/**
 * Created by IntelliJ IDEA.
 * User: julian
 * Date: Feb 23, 2007
 * Time: 3:27:35 AM
 */
public class GPController implements Controller, Evolvable {

    private DoubleGP gp;

    public GPController(DoubleGP gp) {
        this.gp = gp;
    }

    public GPController(){
        this.gp = new DoubleGP (8, 2, 5, 3);
    }

    public void mutate() {
        gp.mutate ();
    }

    public Evolvable copy() {
        return new GPController (gp.copy ());
    }
    
    public void reset() {
        gp.reset ();
    }

    public int control(SensorModel model) {
        double[] inputs = {1, model.getSpeed (), model.getAngleToNextWaypoint (),
                model.getDistanceToNextWaypoint (),
                model.getAngleToNextNextWaypoint (), model.getDistanceToNextNextWaypoint (),
                model.getAngleToOtherVehicle (), model.getDistanceToOtherVehicle ()};
        double[] output = gp.approximate (inputs);
        int driving = output[0] < -0.3 ? 0 : (output[0] > 0.3 ? 2 : 1);
        int steering = output[1] < -0.3 ? 0 : (output[1] > 0.3 ? 2 : 1);
        return driving * 3 + steering;
    }
}
