package simplerace;

/**
 * Created by IntelliJ IDEA.
 * User: jtogel
 * Date: 12-Oct-2006
 * Time: 19:07:59
 */
public class MLPController implements Controller, Evolvable {

    MLP mlp;

    public MLPController () {
        this.mlp = new MLP (8, 6, 2);
    }

    private MLPController (MLP mlp) {
        this.mlp = mlp;
    }

    public int control (SensorModel model) {
        double[] inputs = {1, model.getSpeed (), model.getAngleToNextWaypoint (), model.getDistanceToNextWaypoint (),
            model.getAngleToNextNextWaypoint (), model.getDistanceToNextNextWaypoint (),
                model.getAngleToOtherVehicle (), model.getDistanceToOtherVehicle ()};
        double[] output = mlp.propagate (inputs);
        int driving = output[0] < -0.3 ? 0 : (output[0] > 0.3 ? 2 : 1);
        int steering = output[1] < -0.3 ? 0 : (output[1] > 0.3 ? 2 : 1);
        return driving * 3 + steering;
    }

    public void mutate () {
        mlp.mutate ();
    }

    public Evolvable copy () {
        return new MLPController (mlp.copy ());
    }

    public void reset () {
        // Not needed here, as we have a reactive controller
    }
}
