package simplerace;

/**
 * Created by IntelliJ IDEA.
 * User: julian
 * Date: Jun 28, 2007
 * Time: 2:54:16 AM
 */
public class PerceptronController implements Controller, Evolvable {

    Perceptron perceptron;

    public PerceptronController() {
        this.perceptron = new Perceptron (8, 2);
    }

    private PerceptronController (Perceptron perceptron) {
        this.perceptron = perceptron;
    }

    public int control(SensorModel model) {
        double[] inputs = {1, model.getSpeed (), model.getAngleToNextWaypoint (), model.getDistanceToNextWaypoint (),
                model.getAngleToNextNextWaypoint (), model.getDistanceToNextNextWaypoint (),
                model.getAngleToOtherVehicle (), model.getDistanceToOtherVehicle ()};
        double[] output = perceptron.propagate (inputs);
        int driving = output[0] < -0.3 ? 0 : (output[0] > 0.3 ? 2 : 1);
        int steering = output[1] < -0.3 ? 0 : (output[1] > 0.3 ? 2 : 1);
        return driving * 3 + steering;
    }

    public void mutate() {
        perceptron.mutate ();
    }

    public Evolvable copy() {
        return new PerceptronController (perceptron.copy ());
    }

    public void reset() {
        // Not needed here, as we have a reactive controller
    }
}