package simplerace;

import wox.serial.Easy;

/**
 * Created by IntelliJ IDEA.
 * User: jtogel
 * Date: 18-Oct-2006
 * Time: 01:24:38
 */
public class Play {

    public static void main (String[] args) {
        Controller firstController = new KeyboardControllerOne ();
        Controller secondController = null;
        if (args.length > 0) {
            firstController = load (args[0]);
        }
        if (args.length > 1) {
            secondController = load (args[1]);
        }
        Track track = new BasicTrack ();
        if (secondController == null) {
            // solo run
            System.out.println ("Score: " + Evaluator.evaluateSolo (firstController, track, true));
        }
        else {
            // competition!
            double[] scores = Evaluator.evaluateDuo (firstController, secondController, track, true);
            System.out.println ("Scores: " + scores[0] + " and " + scores[1]);
        }

    }

    public static Controller load (String name) {
        Controller controller;
        try {
            controller = (Controller) (Object) Class.forName (name).newInstance ();
        }
        catch (ClassNotFoundException e) {
            System.out.println (name + " is not a class name; trying to load a wox definition with that name.");
            controller = (Controller) Easy.load (name);
        }
        catch (Exception e) {
            e.printStackTrace ();
            controller = null;
            System.exit (0);
        }
        return controller;
    }

}
