package simplerace;

/**
 * Created by IntelliJ IDEA.
 * User: jtogel
 * Date: 24-Oct-2006
 * Time: 02:56:18
 */
public class RMLPController implements Controller, Evolvable {

    RMLP mlp;

    final boolean fixSpeed = false;

    public RMLPController () {
        this.mlp = new RMLP (8, 8, 2);
    }

    private RMLPController (RMLP mlp) {
        this.mlp = mlp;
    }

    public int control (SensorModel model) {
        double[] inputs = {1, model.getSpeed (), model.getAngleToNextWaypoint (),
                model.getDistanceToNextWaypoint (),
            model.getAngleToNextNextWaypoint (), model.getDistanceToNextNextWaypoint (),
                model.getAngleToOtherVehicle (), model.getDistanceToOtherVehicle ()};
        double[] output = mlp.propagate (inputs);
        int driving = output[0] < -0.3 ? 0 : (output[0] > 0.3 ? 2 : 1);
        if (fixSpeed) {
            if (model.getSpeed () < 2)
                driving = 2;
            else
                driving = 1;
        }
        
        int steering = output[1] < -0.3 ? 0 : (output[1] > 0.3 ? 2 : 1);
        return driving * 3 + steering;
    }

    public void mutate () {
        mlp.mutate ();
    }

    public Evolvable copy () {
        return new RMLPController (mlp.copy ());
    }

    public void reset () {
        mlp.reset ();
    }
}
