package simplerace;

import java.awt.event.KeyAdapter;

/**
 * Created by IntelliJ IDEA.
 * User: julian
 * Date: Jun 27, 2007
 * Time: 7:38:38 PM
 */
public class ReinforcingEvaluator implements Constants {

    public static double evaluateSolo(Controller controller, Track track, boolean visual) {
        if (!(controller instanceof Reinforcable)) {
            throw new RuntimeException ("ReinforcingEvaluator only works with Reinforcable controllers");
        }
        Vehicle vehicle = new Car ();
        track.reset ();
        track.setFirstVehicle (vehicle, true);
        SensorModel sensors = track.getFirstSensorModel ();
        View view = null;
        Simulation simulation = new BasicSimulator (track, vehicle, null);
        if (visual) {
            view = new View (vehicle, null, track);
            Evaluator.initializeVisual (view,
                    controller instanceof KeyAdapter ? (KeyAdapter) controller : null,
                    null);
        }
        double oldFitness = track.getFirstFitness ();
        for (int i = 0; i < 1000; i++) {
            double reinforcement = 0;
            int command = controller.control (sensors);
            simulation.update (command, neutral);
            if (track.getFirstFitness () > oldFitness) {
                reinforcement = 0;
            }
            else {
                reinforcement = -1;
            }
            if (visual) {
                System.out.println (reinforcement);
            }
            ((Reinforcable) controller).reinforce (reinforcement);
            oldFitness = track.getFirstFitness ();
            if (visual) {
                view.repaint ();
                try {
                    Thread.sleep (50);
                }
                catch (Exception e) {
                    e.printStackTrace ();
                }
            }
        }
        return track.getFirstFitness ();
    }


}
