package simplerace;

/**
 * Created by IntelliJ IDEA.
 * User: jtogel
 * Date: 24-Oct-2006
 * Time: 04:03:27
 */
public class Stats {

    final static int trials = 500;

    public static void main (String[] args) {
        Controller firstController= Play.load (args[0]);;
        Controller secondController = null;
        if (args.length > 1) {
            secondController = Play.load (args[1]);
            StatisticalSummary[] results = duoStats (firstController, secondController);
            System.out.println ("Red car (first controller): \n" + results[0] + "\n");
            System.out.print ("Blue car (second controller): \n" + results[1] + "\n");;

        }
        else {
            StatisticalSummary ss = soloStats (firstController);
            System.out.println (ss);
        }
    }

    public static StatisticalSummary soloStats (Controller firstController) {
        StatisticalSummary ss = new StatisticalSummary ();
        for (int i = 0; i < trials; i++) {
            firstController.reset ();
            ss.add (Evaluator.evaluateSolo (firstController, new BasicTrack (), false));
        }
        return ss;
    }

    public static StatisticalSummary[] duoStats (Controller firstController, Controller secondController) {
        StatisticalSummary ssred = new StatisticalSummary ();
        StatisticalSummary ssblue = new StatisticalSummary ();
        for (int i = 0; i < trials; i++) {
            firstController.reset ();
            secondController.reset ();
            double[] results = Evaluator.evaluateDuo (firstController, secondController, new BasicTrack (), false);
            ssred.add (results[0]);
            ssblue.add (results[1]);
        }
        return new StatisticalSummary[]{ssred, ssblue};
    }

    

}
