package simplerace;

import wox.serial.Easy;

/**
 * Created by IntelliJ IDEA.
 * User: julian
 * Date: 08-May-2007
 * Time: 19:55:35
 */
public class TDLearn {

    public static void main(String[] args) {
        int epochs = 100;
        Evolvable bestController = null;
        double bestScore = Double.NEGATIVE_INFINITY;
        Evolvable initialController;
        if (args.length > 0) {
            initialController = (Evolvable) Play.load (args[0]);
        } else {
            initialController = new MLPController ();
        }
        if (args.length > 1) {
            epochs = Integer.parseInt (args[1]);
        }
        boolean visual = false;
        if (args.length > 2) {
            visual = true;
        }
        for (int epoch = 0; epoch < epochs; epoch++) {
            System.out.print ("Epoch " + epoch + ": ");
            double lastScore = ReinforcingEvaluator.evaluateSolo
                    ((Controller) initialController, new BasicTrack (), visual);
            System.out.print (lastScore);
            if (lastScore > bestScore) {
                bestController = initialController.copy ();
                bestScore = lastScore;
            }
            System.out.println ();
        }
        Easy.save (initialController, "td-last.xml");
        Easy.save (bestController, "td-best.xml");
    }

}
