package simplerace;

import java.awt.*;

/**
 * Created by IntelliJ IDEA.
 * User: jtogel
 * Date: 07-Oct-2006
 * Time: 20:13:57
 */
public interface Vehicle {

    public boolean update (int command);

    public Vector2d getPosition ();

    public Vector2d getVelocity ();

    public double getOrientation ();

    public double getAngularVelocity ();

    public void setPosition (double x, double y);

    public void setVelocity (double x, double y);

    public void setOrientation (double orientation);

    public void setAngularVelocity (double angularVelocity);

    public Vehicle copy ();

    // The following only needs to be implemented when collisions with other vehicles
    // need to be dealt with

    // The point at which this another vehicle intersects with this vehicle, if any
    // if no collision, null is returned
    public Vector2d collisionWith (Vehicle other);

    public void impact (Vector2d otherPosition, Vector2d otherVelocity, double otherMass);

    public Polygon getPolygon ();
    
    public boolean justCollided ();

}
